# Extract.py

import os
from dbtable import *
datadir = "./cru/"

# Extract file names and countries
files = os.listdir(datadir)
countries = []
filenames = []
for file in files:
    index = file.find(".tmp")
    if index > 0:
        countries.append(file[22:index])
        filenames.append(datadir + file)
        
# Extract data        
for i in range(len(countries)):
    table = DbTable("year", "jan", "feb", "mar", "apr", "may", 
                    "jun", "jul", "aug", "sep", "oct", "nov", "dec", 
                    "season1", "season2", "season3", "season4", "annual")
    with open(filenames[i]) as f:
        data = f.readlines()
        for line in data:
            if line[1].isdigit():
                entries = line.split()
                row = [float(entries[k]) for k in range(len(entries))]
                row[0] = int(row[0])
                table.insert(row)
    table.save("climate.db", countries[i])
    print "Country", countries[i], "saved."       
print "done"             
 