from machine import UART

def parseGPS(data):
    s = data.split(",")
    if s[6] == '0':
        print("no GPS data available")
        return None       
    time = s[1][0:2] + ":" + s[1][2:4] + ":" + s[1][4:6]
    lat = convert(s[2])
    dirLat = s[3]
    lon = convert(s[4])
    dirLon = s[5]
    alt = s[9] + " m"
    sat = s[7]
    return time, lat, dirLat, lon, dirLon, alt, sat

def convert(coord):
    # DDDMM.MMMMM -> DD deg MM.MMMMM min
    v = coord.split(".")
    head = v[0]
    tail =  v[1]
    deg = head[0:-2]
    min = head[-2:]
    return deg + " deg " + min + "." + tail + " min"

uart = UART(1, baudrate = 9600, rx = 19) # tx not used
print("starting")
inLine = False
while True:
    ch = uart.read(1)
    if ch == None:
        continue
    if ch == b'$':
        line = bytearray()
        inLine = True
    if inLine:
        line += ch
        if ch == b'\n':
            inLine = False
            line = bytes(line).decode('utf-8')
#            print(line)
            if line[0:6] == "$GPGGA": 
                parsed = parseGPS(line)
                if parsed != None:
                    time, lat, dirLat, lon, dirLon, alt, sat = parsed 
                    print("Time(UTC): %s-- Latitude: %s(%s)-- Longitude:%s(%s)\
-- Altitute:%s--(%s satellites)" %(time, lat, dirLat, lon, dirLon, alt, sat)) 
