# CatchTheEgg.py
# Final version

from microbit import *
from random import randint

def moveEgg():
    global y, yOld, x, xOld
    # erase old egg
    display.set_pixel(xOld, yOld, 0)
    # draw new egg
    display.set_pixel(x, y, 9)
    # update position
    yOld = y
    xOld = x
    y = y + 1
    if y == 5:
        y = 0
        x = randint(0, 4)
  
def moveBasket():
    global z
    # erase old basket
    display.set_pixel(z, 4, 0)
    # determine new position
    acc = accelerometer.get_x()
    if acc < -200 and z > 0:
        z -= 1
    elif acc >  200 and z < 4:
        z += 1
    # draw new basket    
    display.set_pixel(z, 4, 9)

# Initialization
x = randint(0, 4)
xOld = 4
y = 0
yOld = 4
z = 0
hits = 0
nbGames = 0

# Animation loop
while nbGames < 10:
    moveEgg()
    moveBasket()
    if yOld == 4: # egg at bottom
        nbGames += 1
        sleep(1000)    
        if xOld == z:  # hit
            display.show(Image.YES, clear = True)
            hits += 1
        else: # miss
            display.show(Image.NO, clear = True)
    sleep(300)  # animation speed
display.scroll(str(hits), loop = True)
